#ifndef _GRAPHIK_H_
#define _GRAPHIK_H_

void PlotResults1D(double* xData, double* yData, int dataSize) 
// 1D Funktion als Gnuplot: Option: GraphikAusgabe in .png File
// Funktion ist punktweise gegeben, d.h.
// Input: xData,yData..double Felder der L\"ange datasize
{  
  const char * commandsForGnuplot[] = {
           "set title \"Werte\" ",
           "set terminal png",
           "set output \"plot1d.png\" ",
	   "plot 'data.temp' with linespoints",
           "replot"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
  char output;
  int i,k;
    output='n';
    cout <<"Ausgabe in Datei"<<endl;
    cin >>output;
    k=1;
    if (output=='n')
      {
	k=3;
      }
    for (i=0; i < dataSize; i++)
    {
    fprintf(temp, "%f %.15f \n", xData[i], yData[i]); 
    }
    for (i=0; (i*k) < 4; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[k*i]); 
    }
    //    pclose(gnuplotPipe);
}

void PlotResults1DLog(double* xData, double* yData, int dataSize) 
// 1D Funktion als Gnuplot: Option: GraphikAusgabe in .png File
// Funktion ist punktweise gegeben
// Input: xData,yData..double Felder der L\"ange datasize
// y-Achse wird logarithmisch gezeichnet
{  
  const char * commandsForGnuplot[] = {
           "set title \"Werte\" ",
           "set terminal png",
           "set logscale y",
           "set output \"plot1d.png\" ",
	   "plot 'data.temp' with points",
           "replot"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
  char output;
  int i,k;
    output='n';
    cout <<"Ausgabe in Datei"<<endl;
    cin >>output;
    k=1;
    if (output=='n')
      {
	k=2;
      }
    for (i=0; i < dataSize; i++)
    {
    fprintf(temp, "%f %.15f \n", xData[i], yData[i]); 
    }
    for (i=0; (i*k) < 5; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[k*i]); 
    }
    //    pclose(gnuplotPipe);
}

void PlotResults3D(double* xData, double* yData, double* zData, int dataSize) 
// 3D-Vektoren in Gnuplot zeichnen
// Input: xData,yData,zData..double Felder der L\"ange datasize
{  
  const char * commandsForGnuplot[] = 
              {"set title \"Werte\" ",
               "set palette rgb 33,13,10",
               "splot 'data.temp'"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
    int i;
    for (i=0; i < dataSize; i++)
    {
      fprintf(temp, "%f %f %f\n", xData[i], yData[i],zData[i]); 
    }
    for (i=0; i < 3; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[i]); 
    }
    pclose(gnuplotPipe);
}



void PlotResults2D(double* xData, double* yData, double* zData, int dataSize) 
// 2D-Funktion z=f(x,y) in Gnuplot zeichnen, Funktion ist punktweise gegeben
// Input: xData,yData,zData..double Felder der L\"ange datasize
// z-Achse wird farbig dargestellt
{  
  const char * commandsForGnuplot[] = 
              {"set title \"Werte\" ",
               "set palette rgb 33,13,10",
               "set view map",
               "splot 'data.temp' with points palette pt 5 ps 0.5"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
    int i;
    for (i=0; i < dataSize; i++)
    {
      fprintf(temp, "%f %f %f\n", xData[i], yData[i],zData[i]); 
    }
    for (i=0; i < 4; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[i]); 
    }
    pclose(gnuplotPipe);
}

void plotFunction(int d,int* m,int n,double* x)
{ // stellt Gitterfunktion x auf [0,1]^d graphisch dar:
  // Input: m[k] anzahl der gitterpunkte in k-te Richtung
  double* b;
  double* y;
  int i;
  double h;
  y=(double*)malloc(n*sizeof(double)); 
  b=(double*)malloc(n*sizeof(double)); 
  h=1/double(m[0]+1);
   for (i=0;i<m[0];i++)
      {
	b[i]=(i+1)*h;
      }
   if (d<2)
     {
      PlotResults1D(b,x,n);
     }
   else
     {
       if (d<3)
	 {
           y=(double*)malloc(n*sizeof(double)); 
           h=1/double(m[1]+1);
           for (i=0;i<m[1];i++)
           {
   	    y[i*m[0]]=(i+1)*h;
            vdcopy(m[0],&b[i*m[0]],1,b,1);
           }
           for (i=1;i<m[0];i++)
           {
            vdcopy(m[1],&y[i],m[0],y,m[0]);
           }
           PlotResults2D(b,y,x,n);
	 }
     }
}

void Farben(long int* cData)
// Farben fuer die Balken in Gnuplot in rgb
{
  cData[0]=65536*128+256*128+128;
  cData[1]=65536*128+256*0  +128;
  cData[5]=65536*  0+256*  0+  0;
  cData[6]=65536*  0+256*228+255;  
  cData[11]=65536*255+256*  0+255; 
  cData[12]=65536*  0+256*128+128; 
  cData[16]=65536*255+256*128+  0; 
  cData[21]=65536*255+256*  0+  0; 
  cData[26]=65536*230+256*200+  0; 
  cData[31]=65536*  0+256*200+  0; 
  cData[37]=65536*  0+256*  0+255; 
  cData[2]=cData[0]; 
  cData[3]=cData[1]; 
  cData[4]=cData[0]; 
  cData[7]=cData[0]; 
  cData[8]=cData[6]; 
  cData[9]=cData[6]; 
  cData[10]=cData[0]; 
  cData[13]=cData[11];
  cData[14]=cData[11]; 
  cData[15]=cData[5]; 
  cData[17]=cData[0]; 
  cData[18]=cData[16]; 
  cData[19]=cData[16]; 
  cData[20]=cData[0]; 
  cData[22]=cData[2]; 
  cData[23]=cData[21];
  cData[24]=cData[21]; 
  cData[25]=cData[5]; 
  cData[27]=cData[26]; 
  cData[28]=cData[12]; 
  cData[29]=cData[26]; 
  cData[30]=cData[0]; 
  cData[32]=cData[31]; 
  cData[33]=cData[0];
  cData[34]=cData[31]; 
  cData[35]=cData[5]; 
  cData[36]=cData[0]; 
  cData[38]=cData[0];
  cData[39]=cData[37];
}


void PlotBalken(long int* zData, int dataSize,long int* cData) 
// fuer monopoly werdeb die absoluten Haeufigkeiten von zData in den Farben der Strassen gezeichnet:
// Input: zData: Feld der L\"ange 40, (abs. Hauf.
//        dataSize: Groesse, d.h. 40
//        cData: Hilfsfeld fuer die Farben der Strassen
{  
  const char * commandsForGnuplot[] = {"set title \"Werte\" ",
                                 "set xtics ('L' 0,'B' 1,'G' 2,'T' 3,'S' 4,'S' 5,'C' 6,'E' 7,'E' 8,'P' 9,'G' 10,'S' 11,'E' 12,'H' 13,'N' 14,'W' 15,'M' 16,'G' 17,'W' 18,'B' 19,'F' 20,'T' 21,'E' 22,'M' 23,'O' 24,'N' 25,'L' 26,'S' 27,'W' 28,'G' 29,'G' 30,'R' 31,'H' 32,'G' 33,'B' 34,'H' 35,'E' 36,'P' 37,'S' 38,'S' 39)",
      "set style fill solid 1.0",
      "plot 'data.temp' using 1:2:3:($4) with boxes lw 9 lc rgb variable",
      "replot"
                                 };
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
    int i;
    for (i=0; i < dataSize; i++)
    {
      fprintf(temp, "%i %li %i %li\n", i,zData[i],0,cData[i]); 
    }
    for (i=0; i < 5; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[i]); 
    }
    
}
#endif
